unit EmRubyForm;

interface

uses
  Windows,
  SysUtils,
  Controls,
  Forms,
  plugin,
  Apollo,
  Buttons,
  ShlObj,
  ComObj,
  StdCtrls,
  ComCtrls,
  ToolWin,
  Classes;

type
  TfrmEmRuby = class(TForm)
    Memo1: TMemo;
    ToolBar1: TToolBar;
    SpeedButton1: TSpeedButton;
    ToolButton1: TToolButton;
    SpeedButton2: TSpeedButton;
    ToolButton2: TToolButton;
    chkSelectArea: TCheckBox;
    CoolBar1: TCoolBar;
    ToolBar2: TToolBar;
    ToolButton3: TToolButton;
    cboScripts: TComboBox;
    SpeedButton3: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cboScriptsChange(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private 錾 }
    m_hwnd: HWND;
    m_strScriptDir: String;
  public
    { Public 錾 }
    procedure SetHWND(hWndEditor: HWND);
    procedure RefreshCombo();
  end;

var
  frmEmRuby: TfrmEmRuby;

implementation

{$R *.dfm}

procedure TfrmEmRuby.RefreshCombo();
var
    sr: TSearchRec;
begin
    cboScripts.Clear;
    if FindFirst(m_strScriptDir + '\*.rb',
    		faDirectory or faAnyFile, sr) = 0 then begin
        repeat
            cboScripts.Items.Append(sr.Name);
        until FindNext(sr) <> 0;
        FindClose(sr);
    end;
end;

procedure TfrmEmRuby.SetHWND(hWndEditor: HWND);
var
    rcEditor: TRect;
    ptCenter: TPoint;
    pidl: PItemIDList;
    Buffer: Array[0..MAX_PATH-1] of Char;
begin
    m_hwnd := hWndEditor;

    GetWindowRect(hWndEditor, rcEditor);
    ptCenter := Point(
        (rcEditor.Left + rcEditor.Right) div 2,
        (rcEditor.Top + rcEditor.Bottom) div 2);
    Left := ptCenter.X - Width div 2;
    Top := ptCenter.Y - Height div 2;
    if Left < 0 then Left := 0;
    if Top < 0 then Top := 0;

    chkSelectArea.Checked := (Editor_GetSelType(m_hwnd) <> SEL_TYPE_NONE);

    SHGetSpecialFolderLocation(0, CSIDL_PERSONAL, pidl);
    SHGetPathFromIDList(pidl, Buffer);

    m_strScriptDir := Buffer;

    if m_strScriptDir[Length(m_strScriptDir) - 1] <> '\' then
        m_strScriptDir := m_strScriptDir + '\';
    m_strScriptDir := m_strScriptDir + 'EmRuby';
    if not DirectoryExists(m_strScriptDir) then
        CreateDir(m_strScriptDir);

    RefreshCombo;
end;


procedure TfrmEmRuby.SpeedButton1Click(Sender: TObject);
var
	szLine: PChar;
    nSize: Integer;
    slArgs, slResult: TStringList;
    aplScript:  TApollo;
begin
    slArgs := TStringList.Create;
    slResult := TStringList.Create;
    aplScript := TApollo.Create(nil);
    try
        // R[hSJIS
        slArgs.Text := '$KCODE = "SJIS"';
        aplScript.Script := slArgs;
        aplScript.Execute(nil);

        slArgs.Clear;
        if not chkSelectArea.Checked then
            Editor_ExecCommand(m_hwnd, EEID_EDIT_SELECT_ALL);
        // I͈͂̎擾
        nSize := Editor_GetSelTextA(m_hwnd, 0, nil);
        GetMem(szLine, nSize + 1);
        ZeroMemory(szLine, nSize + 1);
        try
            Editor_GetSelTextA(m_hwnd, nSize, szLine);
            slArgs.Text := szLine;
        finally
            FreeMem(szLine, nSize + 1);
        end;

        Editor_ExecCommand(m_hwnd, EEID_DELETE);

        aplScript.Script.Assign(Memo1.Lines);
        aplScript.Params.Assign(slArgs);
        aplScript.Execute(slResult);
        Editor_InsertStringA(m_hwnd, PChar(slResult.Text));
    finally
        slArgs.Free;
        slResult.Free;
        aplScript.Free;
    end;

    Close;
end;

procedure TfrmEmRuby.SpeedButton2Click(Sender: TObject);
begin
    Close;
end;

procedure TfrmEmRuby.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_ESCAPE then begin
        Close;
    end;
end;

procedure TfrmEmRuby.cboScriptsChange(Sender: TObject);
begin
    if (cboScripts.ItemIndex <> - 1) and FileExists(m_strScriptDir + '\' + cboScripts.Text) then begin
        Memo1.Lines.LoadFromFile(m_strScriptDir + '\' + cboScripts.Text);
    end;
end;

procedure TfrmEmRuby.SpeedButton3Click(Sender: TObject);
begin
    RefreshCombo;
end;

end.
